﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
		import flash.geom.ColorTransform;
		import flash.filters.BitmapFilterQuality;
import flash.filters.GlowFilter;
	/*
	*	Le principe des courbes de lissajou est basé sur la composition de 2 mouvements sinusoidales
	*	Un mouvement d'aller-retour horizontal
	*	Un mouvement d'aller-retour vertical
	*	La difference entre les vitesses d'implémentation de l'angle vont créer des courbes très différentes
	*	La difference des rayons d'angle également.
	*/
	public class Lissajou extends Sprite
	{
		private var background:Bitmap;
		private var data:BitmapData;
		private var horizontal_support:Sprite;
		private var horizontal_angle:Number = 30;
		private var vertical_support:Sprite;
		private var vertical_angle:Number = 30;
		private var canevas:Sprite;
		private var vitesseH:Number;
		private var vitesseV:Number;
		
		
		public function Lissajou()
		{
			data = new BitmapData(600,600,false,0x000000);
			background = new Bitmap(data);
			
			addChild(background);
			canevas = new Sprite();	
			addChild(canevas);
			
			/*
			 * PARAMETRAGE DES VITESSES 
			 * EN MODIFIANT CES PARAMETRES VOUS AUREZ DES COURBES VARIANTES
			 */
			vitesseH = 0.2;
			vitesseV = 5;
			
			
			buildHorizontalMovement();
		}
		
		private function buildHorizontalMovement():void
		{
			horizontal_support = new Sprite();
			horizontal_support.x= 100;
			horizontal_support.y= 300;
			
			canevas.addChild(horizontal_support);
			
			horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter_handler);
			
			buildVerticalMovement(horizontal_support);
		}
		
		private function horizontal_enter_handler(e:Event):void
		{
			horizontal_angle+=vitesseH;
			e.currentTarget.x = Math.sin(horizontal_angle*Math.PI/280)*300+300;
		}
		
		private function buildVerticalMovement(clip:Sprite):void
		{
			vertical_support = new Sprite();
			vertical_support.graphics.beginFill(0x606060,0.2);
			vertical_support.graphics.drawCircle(0,10,10);
			vertical_support.graphics.endFill();
			
			
			clip.addChild(vertical_support);
			
			vertical_support.addEventListener(Event.ENTER_FRAME,vertical_enter_handler);
		}
		
		private function vertical_enter_handler(e:Event):void
		{
			vertical_angle+=vitesseV;
			e.currentTarget.y = Math.sin(vertical_angle*Math.PI/180)*300-10;
			e.currentTarget.transform.colorTransform = new ColorTransform( /*Rouge*/ Math.random(),/*Vert*/2,/*Bleu*/10,Math.random(),0, 0, 1, Math.random());
			var glow:GlowFilter = new GlowFilter();
glow.color = 0x00FFFF;
glow.alpha = 1;
glow.blurX = 25;
glow.blurY = 25;
glow.quality = BitmapFilterQuality.MEDIUM;

e.currentTarget.filters = [glow];
			data.draw(canevas);
		}
	}
}